| IGLib 1.4 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files
- Directories

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Member Functions | Protected Attributes | Properties | Private Member Functions | Private Attributes

# IG::Neural::NeuralTrainingLimits Class Reference

Contains Parameters that define neural network architecture limits and trainig parameter limits. Not thread safe! More...

Collaboration diagram for IG::Neural::NeuralTrainingLimits:
[legend]

List of all members.

## Public Member Functions
void | PrepareNumHiddenNeuronsValuesArray (int numLayers, params int[] numHiddenNeuronsValues)
| Prepares values of numbers of neurons in individual layers according to parameters. For each layer, numbers of neurons in that layers to be used in the table are the same.
void | PrepareNumHiddenNeuronsValuesArray (int numLayers, int minNumNeurons, int maxNumNeurons, int numValues, double intervalGrowthFactor)
| Prepares values of numbers of neurons in individual layers according to parameters in such a way that intervals between these values grow exponentially.
delegate void | DoForParameters (List< NeuralTrainingParameters > trainingParameters, List< int > dimensions, int which)
void | DoForParameters_CreateTable (List< NeuralTrainingParameters > trainingParameters, List< int > dimensions, int which)
void | CreateTrainingTable (List< NeuralTrainingParameters > trainingParameters, List< int > tableDimensions)
| Creates a table of training parameters.
void | CreateTrainingTable (List< NeuralTrainingParameters > trainingParameters)
| Creates a table of training parameters.
void | IterateThroughMultidimensionalTable (List< NeuralTrainingParameters > tableResults, List< int > tableDimensions, bool createTable, bool createDimensions, DoForParameters doOnElement)
| Iterates through all elements of the table of training results defined by the current object, and does whatever is specified by the parameters.
## Static Public Member Functions
static void | SaveJson (NeuralTrainingLimits trainingLimits, string filePath)
| Saves (serializes) the specified array of training limits objects to the specified JSON file. File is owerwritten if it exists.
static void | SaveJson (NeuralTrainingLimits trainingLimits, string filePath, bool append)
| Saves (serializes) the specified array of training limits objects to the specified JSON file.
static void | LoadJson (string filePath, ref NeuralTrainingLimits trainingLimits)
| Restores (deserializes) an array of training parameters objects from the specified file in JSON format.
## Static Public Attributes
static double | DefaultLearningRateMin = 0.1
| Default value for minimum learning rate in neural networks.
static double | DefaultLearningRateMax = 0.6
| Default value for maximum learning rate in neural networks.
static int | DefaultLearningRateNum = 5
| Default value for number of learning rates in neural networks.
static double | DefaultMomentumMin = 0.3
| Default value for minimum momentum in neural networks.
static double | DefaultMomentumMax = 0.8
| Default value for maximum momentum in neural networks.
static int | DefaultMomentumNum = 5
| Default value for number of momentums in neural networks.
static double | DefaultAlphaMin = 1.0
| Default value for minimum alpha value in neural networks.
static double | DefaultAlphaMax = 2.0
| Default value for maximum alpha value in neural networks.
static int | DefaultAlphaNum = 5
| Default value for number of alpha values in neural networks.
static double | DefaultInputSafetyFactorMin = 1.4
| Default value for minimum input bound safety factor value in neural networks.
static double | DefaultInputSafetyFactorMax = 1.4
| Default value for maximum input bound safety factor value in neural networks.
static int | DefaultInputSafetyFactorNum = 1
| Default value for number of input bound safety factors values in neural networks.
static double | DefaultOutputSafetyFactorMin = 1.4
| Default value for minimum output bound safety factor value in neural networks.
static double | DefaultOutputSafetyFactorMax = 1.4
| Default value for maximum output bound safety factor value in neural networks.
static int | DefaultOutputSafetyFactorNum = 1
| Default value for number of output bound safety factors values in neural networks.
static bool | DefaultEnableArchitectureTest = false
| Default flag for enabling different layers in neural networks.
static int | DefaultNumHiddenLayersNum = 1
| Default value for number of hidden layers in neural networks.
static int | DefaultNumHiddenNeuronsFirstMin = 5
| Default value for number of hidden neurons in first hidden layer in neural networks.
static int | DefaultNumHiddenNeuronsFirstMax = 25
| Default value for number of hidden neurons in first hidden layer in neural networks.
static int | DefaultNumHiddenNeuronsFirstNum = 1
| Default value for number of hidden neurons in first hidden layer in neural networks.
static int | DefaultNumHiddenNeuronsSecondMin = 2
| Default value for number of hidden neurons in second hidden layer in neural networks.
static int | DefaultNumHiddenNeuronsSecondMax = 10
| Default value for number of hidden neurons in second hidden layer in neural networks.
static int | DefaultNumHiddenNeuronsSecondNum = 1
| Default value for number of hidden neurons in second hidden layer in neural networks.
static int | DefaultNumHiddenNeuronsThirdMin = 2
| Default value for number of hidden neurons in third hidden layer in neural networks.
static int | DefaultNumHiddenNeuronsThirdMax = 10
| Default value for number of hidden neurons in third hidden layer in neural networks.
static int | DefaultNumHiddenNeuronsThirdNum = 1
| Default value for number of hidden neurons in third hidden layer in neural networks.
static int | DefaultMaxEpochs = 1000
| Default value for maximum number of epochs in neural networks.
static int | DefaultEpochBundle = 100
| Default value for number of epochs in bundle in neural networks.
static bool | DefaultEnableRangeTolerance = false
| Flag for enabling toelrance that represent a percentage of the output range.
static int | DefaultInputLenght = 5
| Default value for number of input neurons.
static int | DefaultOutputLenght = 3
| Default value for number of output neurons.
## Protected Member Functions
int[] | GetArrayCopy (int[] original)
| Creates and returns a copy of the specified array of integers.
int[] | GetArrayCopyInt (double[] original)
| Creates and returns an array of integers that is a copy of the specified array of double values (double to integer conversion made by rounding).
## Protected Attributes
double | _learningRateMin = NeuralTrainingParameters.DefaultLearningRate
double | _learningRateMax = NeuralTrainingParameters.DefaultLearningRate
int | _learningRateNum = 1
double | _momentumMin = DefaultMomentumMin
double | _momentumMax = DefaultMomentumMax
int | _momentumNum = DefaultMomentumNum
double | _alphaMin = DefaultAlphaMin
double | _alphaMax = DefaultAlphaMax
int | _alphaNum = DefaultAlphaNum
double | _inputSafetyFactorMin = DefaultInputSafetyFactorMin
double | _inputSafetyFactorMax = DefaultInputSafetyFactorMax
int | _inputSafetyFactorNum = DefaultInputSafetyFactorNum
double | _outputSafetyFactorMin = DefaultOutputSafetyFactorMin
double | _outputSafetyFactorMax = DefaultOutputSafetyFactorMax
int | _outputSafetyFactorNum = DefaultOutputSafetyFactorNum
int | _maxEpochs = DefaultMaxEpochs
int | _epochBundle = DefaultEpochBundle
int | _inputLenght = DefaultInputLenght
int | _outputLenght = DefaultOutputLenght
bool | _enableRangeTolerance = DefaultEnableRangeTolerance
IVector | _toleranceRms
IVector | _toleranceMax
bool | _enableArchitectureTest = DefaultEnableArchitectureTest
int | _numHiddenLayersNum = DefaultNumHiddenLayersNum
int | _numHiddenNeuronsFirstMin = DefaultNumHiddenNeuronsFirstMin
int | _numHiddenNeuronsFirstMax = DefaultNumHiddenNeuronsFirstMax
int | _numHiddenNeuronsFirstNum = DefaultNumHiddenNeuronsFirstNum
int[] | _numHiddenNeuronsFirstValues
bool | randomTableEnabled = false
int | _numHiddenNeuronsSecondMin = DefaultNumHiddenNeuronsSecondMin
int | _numHiddenNeuronsSecondMax = DefaultNumHiddenNeuronsSecondMax
int | _numHiddenNeuronsSecondNum = DefaultNumHiddenNeuronsSecondNum
int[] | _numHiddenNeuronsSecondValues
int | _numHiddenNeuronsThirdMin = DefaultNumHiddenNeuronsThirdMin
int | _numHiddenNeuronsThirdMax = DefaultNumHiddenNeuronsThirdMax
int | _numHiddenNeuronsThirdNum = DefaultNumHiddenNeuronsThirdNum
int[] | _numHiddenNeuronsThirdValues
## Properties
double | LearningRateMin`[get, set]`
| Minimum limit for learning rate.
double | LearningRateMax`[get, set]`
| Maximum limit for learning rate.
int | LearningRateNum`[get, set]`
| Number of learning rates.
double | MomentumMin`[get, set]`
| Minimum limit for momentum.
double | MomentumMax`[get, set]`
| Maximum limit for momentum.
int | MomentumNum`[get, set]`
| Number of momentums.
double | AlphaMin`[get, set]`
| Minimum limit for alpha value.
double | AlphaMax`[get, set]`
| Maximum limit for alpha value.
int | AlphaNum`[get, set]`
| Number of alpha value.
double | InputSafetyFactorMin`[get, set]`
| Minimum limit for input safety factor value.
double | InputSafetyFactorMax`[get, set]`
| Maximum limit for input safety factor value.
int | InputSafetyFactorNum`[get, set]`
| Number of input safety factor values.
double | OutputSafetyFactorMin`[get, set]`
| Minimum limit for output safety factor value.
double | OutputSafetyFactorMax`[get, set]`
| Maximum limit for output safety factor value.
int | OutputSafetyFactorNum`[get, set]`
| Number of output safety factor values.
int | MaxEpochs`[get, set]`
| Maximum number of epochs performed in training.
int | EpochBundle`[get, set]`
| Number of epochs in boundle.
int | InputLenght`[get, set]`
| Number of input neurons.
int | OutputLength`[get, set]`
| Number of output neurons.
bool | EnableRangeTolerance`[get, set]`
| Flag for enabling toelrance that represent a percentage of the output range.
IVector | ToleranceRms`[get, set]`
| Tolerance for RMS.
IVector | ToleranceMax`[get, set]`
| Maximum tolerance for max. abs. difference.
IVector | ToleranceRmsRelativeToRange`[get, set]`
| Relative tolerances on RMS errors of outputs over training points, relative to the correspoinding ranges of output data.
double | ToleranceRmsRelativeToRangeScalar`[get, set]`
| Scalar through which all components of the Relative tolerances on RMS errors of outputs can be set to the same value.
IVector | ToleranceMaxRelativeToRange`[get, set]`
| Relative tolerances on max. abs. errors of outputs over training points, relative to the correspoinding ranges of output data.
double | ToleranceMaxRelativeToRangeScalar`[get, set]`
| Scalar through which all components of the Relative tolerances on max. abs. errors of outputs can be set to the same value.
bool | EnableArchitectureTest`[get, set]`
| Flag for enabling test in architecture of ANN.
int | NumHiddenLayersNum`[get, set]`
| Number of hidden layers in neural network.
int | NumHiddenNeuronsFirstMin`[get, set]`
| Minimum number of hidden neurons in first hidden layer.
int | NumHiddenNeuronsFirstMax`[get, set]`
| Maximum number of hidden neurons in first hidden layer.
int | NumHiddenNeuronsFirstNum`[get, set]`
| Number of hidden neurons in first hidden layer.
int[] | NumHiddenNeuronsFirstValues`[get, set]`
| Values of number of hidden neurons in the first layers that will appear in the table.
int | NumHiddenNeuronsSecondMin`[get, set]`
| Minimum number of hidden neurons in second hidden layer.
int | NumHiddenNeuronsSecondMax`[get, set]`
| Maximum number of hidden neurons in second hidden layer.
int | NumHiddenNeuronsSecondNum`[get, set]`
| Number of hidden neurons in second hidden layer.
int[] | NumHiddenNeuronsSecondValues`[get, set]`
| Values of number of hidden neurons in the second layers that will appear in the table.
int | NumHiddenNeuronsThirdMin`[get, set]`
| Minimum number of hidden neurons in third hidden layer.
int | NumHiddenNeuronsThirdMax`[get, set]`
| Maximum number of hidden neurons in third hidden layer.
int | NumHiddenNeuronsThirdNum`[get, set]`
| Number of hidden neurons in third hidden layer.
int[] | NumHiddenNeuronsThirdValues`[get, set]`
| Values of number of hidden neurons in the third layer that will appear in the table.
## Private Member Functions
void | PrepareNeuronsTable (int minNeurons, int maxNeurons, int numNeurons, double growthFactorref, ref int[] neurpnsTable)
| Prepares table of neurons in geometric sequence.
void | PrepareNeuronTable (ref int[] neuronsFirstLayer, ref int[] neuronsSecondLayer, ref int[] neuronsThirdLayer)
## Private Attributes
IVector | _tolRmsRelative
| Auxiliary properties for defining tolerances in a relative way:
double | _tolRmsRelativeScalar = NeuralTrainingParameters.DefaultToleranceRmsRelativeToRangeScalar
IVector | _tolMaxRelative
double | _tolMaxRelativeScalar = NeuralTrainingParameters.DefaultToleranceMaxRelativeToRangeScalar

## Detailed Description

Contains Parameters that define neural network architecture limits and trainig parameter limits.

Not thread safe!

This class is used for storing training parameter limits of neural networks and restoring them at a later time, in order to repeat training under similar condition or simply to analyse performance of neural networks. $A Tako78 Aug12; Igor Aug12 Nov12;

## Member Function Documentation

int [] IG::Neural::NeuralTrainingLimits::GetArrayCopy | ( | int[] | original | ) | `[inline, protected]`

Creates and returns a copy of the specified array of integers.

Parameters:

  original | Array whose copy is returned.

int [] IG::Neural::NeuralTrainingLimits::GetArrayCopyInt | ( | double[] | original | ) | `[inline, protected]`

Creates and returns an array of integers that is a copy of the specified array of double values (double to integer conversion made by rounding).

Parameters:

  original | Array whose copy is returned.

void IG::Neural::NeuralTrainingLimits::PrepareNumHiddenNeuronsValuesArray | ( | int | numLayers,
|  | params int[] | numHiddenNeuronsValues
| ) |  | `[inline]`

Prepares values of numbers of neurons in individual layers according to parameters. For each layer, numbers of neurons in that layers to be used in the table are the same.

Parameters:

  numLayers | Number of hidden layers (this is fixed for the tables where this method is used; the containing class also does not support tables where number of layers would vary).
  numHiddenNeuronsValues | Values for the number of hidden neurons in different layers (common for all layers).

void IG::Neural::NeuralTrainingLimits::PrepareNumHiddenNeuronsValuesArray | ( | int | numLayers,
|  | int | minNumNeurons,
|  | int | maxNumNeurons,
|  | int | numValues,
|  | double | intervalGrowthFactor
| ) |  | `[inline]`

Prepares values of numbers of neurons in individual layers according to parameters in such a way that intervals between these values grow exponentially.

Parameters:

  numLayers | Number of hidden layers (this is fixed for the tables where this method is used; the containing class also does not support tables where number of layers would vary).
  minNumNeurons | Minimal value for the number fo neurons in hidden layers.
  maxNumNeurons | Maxmial value for the number of neurons in hidden layers.
  numValues | Number of values for the number of neurons in hidden layers.
  intervalGrowthFactor | Factor by which length of each next iterval befoore successive values for the number of neurons in hidden layers is extended.

delegate void IG::Neural::NeuralTrainingLimits::DoForParameters | ( | List< NeuralTrainingParameters > | trainingParameters,
|  | List< int > | dimensions,
|  | int | which
| ) |  |

void IG::Neural::NeuralTrainingLimits::DoForParameters_CreateTable | ( | List< NeuralTrainingParameters > | trainingParameters,
|  | List< int > | dimensions,
|  | int | which
| ) |  | `[inline]`

void IG::Neural::NeuralTrainingLimits::CreateTrainingTable | ( | List< NeuralTrainingParameters > | trainingParameters,
|  | List< int > | tableDimensions
| ) |  | `[inline]`

Creates a table of training parameters.

Parameters:

  trainingParameters | List where table of parameters is stored. Must be different than null. Eventual elements already contained will be deleted.
  tableDimensions | List of dimensions of the generated table. If specified then table dimensions will be put on the list (the list is cleared at the beinning).

void IG::Neural::NeuralTrainingLimits::CreateTrainingTable | ( | List< NeuralTrainingParameters > | trainingParameters | ) | `[inline]`

Creates a table of training parameters.

Parameters:

  trainingParameters | List where table of parameters is stored. Must be different than null. Eventual elements already contained will be deleted.

void IG::Neural::NeuralTrainingLimits::PrepareNeuronsTable | ( | int | minNeurons,
|  | int | maxNeurons,
|  | int | numNeurons,
|  | double | growthFactorref,
|  | ref int[] | neurpnsTable
| ) |  | `[inline, private]`

Prepares table of neurons in geometric sequence.

Parameters:

  minNeurons | Minimum number of neurons.
  maxNeurons | Maximum number of neurons.
  numNeurons | Number of neurons in sequence.
  neurpnsTable | Table of neurons.

$A Tako78 Nov12;

void IG::Neural::NeuralTrainingLimits::PrepareNeuronTable | ( | ref int[] | neuronsFirstLayer,
|  | ref int[] | neuronsSecondLayer,
|  | ref int[] | neuronsThirdLayer
| ) |  | `[inline, private]`

void IG::Neural::NeuralTrainingLimits::IterateThroughMultidimensionalTable | ( | List< NeuralTrainingParameters > | tableResults,
|  | List< int > | tableDimensions,
|  | bool | createTable,
|  | bool | createDimensions,
|  | DoForParameters | doOnElement
| ) |  | `[inline]`

Iterates through all elements of the table of training results defined by the current object, and does whatever is specified by the parameters.

Parameters:

  tableResults | Table where training parameters and results are stored. Must be specified when this table is created (i.e. parameter createTable is true) or when something must be done on each element (i.e. function parameter is doOnElement defined).
  tableDimensions | Table where dimensions are stored. Must be specified when the table of dimensions will be created (i.e. the parameter createDimensions is true).
  createTable | Specifies whether the table of training parameters and results will be created by the function call. If true then the parameter tableResults must be specified.
  createDimensions | Specifies whether the table of dimensions will be created when iterating over elements. If true then the parameter tableDimensions must be specified.
  doOnElement | Delegate that is executed on each element of the table. Index of the current element, as well as the table of the resulet (parameter tableResults ) and the table of dimensions (parameter tableDimensions ) are passed to the delegate when executed.

static void IG::Neural::NeuralTrainingLimits::SaveJson | ( | NeuralTrainingLimits | trainingLimits,
|  | string | filePath
| ) |  | `[inline, static]`

Saves (serializes) the specified array of training limits objects to the specified JSON file. File is owerwritten if it exists.

Parameters:

  trainingParameters | Array that is saved to a file.
  filePath | Path to the file into which object is is saved.

static void IG::Neural::NeuralTrainingLimits::SaveJson | ( | NeuralTrainingLimits | trainingLimits,
|  | string | filePath,
|  | bool | append
| ) |  | `[inline, static]`

Saves (serializes) the specified array of training limits objects to the specified JSON file.

Parameters:

  trainingParameters | Array that is saved to a file.
  filePath | Path to the file into which object is is saved.
  append | Specifies whether serialized data is appended at the end of the file in the case that the file already exists.

static void IG::Neural::NeuralTrainingLimits::LoadJson | ( | string | filePath,
|  | ref NeuralTrainingLimits | trainingLimits
| ) |  | `[inline, static]`

Restores (deserializes) an array of training parameters objects from the specified file in JSON format.

Parameters:

  filePath | File from which array of objects is restored.
  trainingParametersRestored | Array of objects that is restored by deserialization.

## Member Data Documentation

double IG::Neural::NeuralTrainingLimits::DefaultLearningRateMin = 0.1`[static]`

Default value for minimum learning rate in neural networks.

double IG::Neural::NeuralTrainingLimits::DefaultLearningRateMax = 0.6`[static]`

Default value for maximum learning rate in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultLearningRateNum = 5`[static]`

Default value for number of learning rates in neural networks.

double IG::Neural::NeuralTrainingLimits::DefaultMomentumMin = 0.3`[static]`

Default value for minimum momentum in neural networks.

double IG::Neural::NeuralTrainingLimits::DefaultMomentumMax = 0.8`[static]`

Default value for maximum momentum in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultMomentumNum = 5`[static]`

Default value for number of momentums in neural networks.

double IG::Neural::NeuralTrainingLimits::DefaultAlphaMin = 1.0`[static]`

Default value for minimum alpha value in neural networks.

double IG::Neural::NeuralTrainingLimits::DefaultAlphaMax = 2.0`[static]`

Default value for maximum alpha value in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultAlphaNum = 5`[static]`

Default value for number of alpha values in neural networks.

double IG::Neural::NeuralTrainingLimits::DefaultInputSafetyFactorMin = 1.4`[static]`

Default value for minimum input bound safety factor value in neural networks.

double IG::Neural::NeuralTrainingLimits::DefaultInputSafetyFactorMax = 1.4`[static]`

Default value for maximum input bound safety factor value in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultInputSafetyFactorNum = 1`[static]`

Default value for number of input bound safety factors values in neural networks.

double IG::Neural::NeuralTrainingLimits::DefaultOutputSafetyFactorMin = 1.4`[static]`

Default value for minimum output bound safety factor value in neural networks.

double IG::Neural::NeuralTrainingLimits::DefaultOutputSafetyFactorMax = 1.4`[static]`

Default value for maximum output bound safety factor value in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultOutputSafetyFactorNum = 1`[static]`

Default value for number of output bound safety factors values in neural networks.

bool IG::Neural::NeuralTrainingLimits::DefaultEnableArchitectureTest = false`[static]`

Default flag for enabling different layers in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultNumHiddenLayersNum = 1`[static]`

Default value for number of hidden layers in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultNumHiddenNeuronsFirstMin = 5`[static]`

Default value for number of hidden neurons in first hidden layer in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultNumHiddenNeuronsFirstMax = 25`[static]`

Default value for number of hidden neurons in first hidden layer in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultNumHiddenNeuronsFirstNum = 1`[static]`

Default value for number of hidden neurons in first hidden layer in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultNumHiddenNeuronsSecondMin = 2`[static]`

Default value for number of hidden neurons in second hidden layer in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultNumHiddenNeuronsSecondMax = 10`[static]`

Default value for number of hidden neurons in second hidden layer in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultNumHiddenNeuronsSecondNum = 1`[static]`

Default value for number of hidden neurons in second hidden layer in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultNumHiddenNeuronsThirdMin = 2`[static]`

Default value for number of hidden neurons in third hidden layer in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultNumHiddenNeuronsThirdMax = 10`[static]`

Default value for number of hidden neurons in third hidden layer in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultNumHiddenNeuronsThirdNum = 1`[static]`

Default value for number of hidden neurons in third hidden layer in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultMaxEpochs = 1000`[static]`

Default value for maximum number of epochs in neural networks.

int IG::Neural::NeuralTrainingLimits::DefaultEpochBundle = 100`[static]`

Default value for number of epochs in bundle in neural networks.

bool IG::Neural::NeuralTrainingLimits::DefaultEnableRangeTolerance = false`[static]`

Flag for enabling toelrance that represent a percentage of the output range.

int IG::Neural::NeuralTrainingLimits::DefaultInputLenght = 5`[static]`

Default value for number of input neurons.

int IG::Neural::NeuralTrainingLimits::DefaultOutputLenght = 3`[static]`

Default value for number of output neurons.

double IG::Neural::NeuralTrainingLimits::_learningRateMin = NeuralTrainingParameters.DefaultLearningRate`[protected]`

double IG::Neural::NeuralTrainingLimits::_learningRateMax = NeuralTrainingParameters.DefaultLearningRate`[protected]`

int IG::Neural::NeuralTrainingLimits::_learningRateNum = 1`[protected]`

double IG::Neural::NeuralTrainingLimits::_momentumMin = DefaultMomentumMin`[protected]`

double IG::Neural::NeuralTrainingLimits::_momentumMax = DefaultMomentumMax`[protected]`

int IG::Neural::NeuralTrainingLimits::_momentumNum = DefaultMomentumNum`[protected]`

double IG::Neural::NeuralTrainingLimits::_alphaMin = DefaultAlphaMin`[protected]`

double IG::Neural::NeuralTrainingLimits::_alphaMax = DefaultAlphaMax`[protected]`

int IG::Neural::NeuralTrainingLimits::_alphaNum = DefaultAlphaNum`[protected]`

double IG::Neural::NeuralTrainingLimits::_inputSafetyFactorMin = DefaultInputSafetyFactorMin`[protected]`

double IG::Neural::NeuralTrainingLimits::_inputSafetyFactorMax = DefaultInputSafetyFactorMax`[protected]`

int IG::Neural::NeuralTrainingLimits::_inputSafetyFactorNum = DefaultInputSafetyFactorNum`[protected]`

double IG::Neural::NeuralTrainingLimits::_outputSafetyFactorMin = DefaultOutputSafetyFactorMin`[protected]`

double IG::Neural::NeuralTrainingLimits::_outputSafetyFactorMax = DefaultOutputSafetyFactorMax`[protected]`

int IG::Neural::NeuralTrainingLimits::_outputSafetyFactorNum = DefaultOutputSafetyFactorNum`[protected]`

int IG::Neural::NeuralTrainingLimits::_maxEpochs = DefaultMaxEpochs`[protected]`

int IG::Neural::NeuralTrainingLimits::_epochBundle = DefaultEpochBundle`[protected]`

int IG::Neural::NeuralTrainingLimits::_inputLenght = DefaultInputLenght`[protected]`

int IG::Neural::NeuralTrainingLimits::_outputLenght = DefaultOutputLenght`[protected]`

bool IG::Neural::NeuralTrainingLimits::_enableRangeTolerance = DefaultEnableRangeTolerance`[protected]`

IVector IG::Neural::NeuralTrainingLimits::_toleranceRms`[protected]`

IVector IG::Neural::NeuralTrainingLimits::_toleranceMax`[protected]`

IVector IG::Neural::NeuralTrainingLimits::_tolRmsRelative`[private]`

Auxiliary properties for defining tolerances in a relative way:

double IG::Neural::NeuralTrainingLimits::_tolRmsRelativeScalar = NeuralTrainingParameters.DefaultToleranceRmsRelativeToRangeScalar`[private]`

IVector IG::Neural::NeuralTrainingLimits::_tolMaxRelative`[private]`

double IG::Neural::NeuralTrainingLimits::_tolMaxRelativeScalar = NeuralTrainingParameters.DefaultToleranceMaxRelativeToRangeScalar`[private]`

bool IG::Neural::NeuralTrainingLimits::_enableArchitectureTest = DefaultEnableArchitectureTest`[protected]`

int IG::Neural::NeuralTrainingLimits::_numHiddenLayersNum = DefaultNumHiddenLayersNum`[protected]`

int IG::Neural::NeuralTrainingLimits::_numHiddenNeuronsFirstMin = DefaultNumHiddenNeuronsFirstMin`[protected]`

int IG::Neural::NeuralTrainingLimits::_numHiddenNeuronsFirstMax = DefaultNumHiddenNeuronsFirstMax`[protected]`

int IG::Neural::NeuralTrainingLimits::_numHiddenNeuronsFirstNum = DefaultNumHiddenNeuronsFirstNum`[protected]`

int [] IG::Neural::NeuralTrainingLimits::_numHiddenNeuronsFirstValues`[protected]`

bool IG::Neural::NeuralTrainingLimits::randomTableEnabled = false`[protected]`

int IG::Neural::NeuralTrainingLimits::_numHiddenNeuronsSecondMin = DefaultNumHiddenNeuronsSecondMin`[protected]`

int IG::Neural::NeuralTrainingLimits::_numHiddenNeuronsSecondMax = DefaultNumHiddenNeuronsSecondMax`[protected]`

int IG::Neural::NeuralTrainingLimits::_numHiddenNeuronsSecondNum = DefaultNumHiddenNeuronsSecondNum`[protected]`

int [] IG::Neural::NeuralTrainingLimits::_numHiddenNeuronsSecondValues`[protected]`

int IG::Neural::NeuralTrainingLimits::_numHiddenNeuronsThirdMin = DefaultNumHiddenNeuronsThirdMin`[protected]`

int IG::Neural::NeuralTrainingLimits::_numHiddenNeuronsThirdMax = DefaultNumHiddenNeuronsThirdMax`[protected]`

int IG::Neural::NeuralTrainingLimits::_numHiddenNeuronsThirdNum = DefaultNumHiddenNeuronsThirdNum`[protected]`

int [] IG::Neural::NeuralTrainingLimits::_numHiddenNeuronsThirdValues`[protected]`

## Property Documentation

double IG::Neural::NeuralTrainingLimits::LearningRateMin`[get, set]`

Minimum limit for learning rate.

double IG::Neural::NeuralTrainingLimits::LearningRateMax`[get, set]`

Maximum limit for learning rate.

int IG::Neural::NeuralTrainingLimits::LearningRateNum`[get, set]`

Number of learning rates.

double IG::Neural::NeuralTrainingLimits::MomentumMin`[get, set]`

Minimum limit for momentum.

double IG::Neural::NeuralTrainingLimits::MomentumMax`[get, set]`

Maximum limit for momentum.

int IG::Neural::NeuralTrainingLimits::MomentumNum`[get, set]`

Number of momentums.

double IG::Neural::NeuralTrainingLimits::AlphaMin`[get, set]`

Minimum limit for alpha value.

double IG::Neural::NeuralTrainingLimits::AlphaMax`[get, set]`

Maximum limit for alpha value.

int IG::Neural::NeuralTrainingLimits::AlphaNum`[get, set]`

Number of alpha value.

double IG::Neural::NeuralTrainingLimits::InputSafetyFactorMin`[get, set]`

Minimum limit for input safety factor value.

double IG::Neural::NeuralTrainingLimits::InputSafetyFactorMax`[get, set]`

Maximum limit for input safety factor value.

int IG::Neural::NeuralTrainingLimits::InputSafetyFactorNum`[get, set]`

Number of input safety factor values.

double IG::Neural::NeuralTrainingLimits::OutputSafetyFactorMin`[get, set]`

Minimum limit for output safety factor value.

double IG::Neural::NeuralTrainingLimits::OutputSafetyFactorMax`[get, set]`

Maximum limit for output safety factor value.

int IG::Neural::NeuralTrainingLimits::OutputSafetyFactorNum`[get, set]`

Number of output safety factor values.

int IG::Neural::NeuralTrainingLimits::MaxEpochs`[get, set]`

Maximum number of epochs performed in training.

int IG::Neural::NeuralTrainingLimits::EpochBundle`[get, set]`

Number of epochs in boundle.

int IG::Neural::NeuralTrainingLimits::InputLenght`[get, set]`

Number of input neurons.

int IG::Neural::NeuralTrainingLimits::OutputLength`[get, set]`

Number of output neurons.

bool IG::Neural::NeuralTrainingLimits::EnableRangeTolerance`[get, set]`

Flag for enabling toelrance that represent a percentage of the output range.

IVector IG::Neural::NeuralTrainingLimits::ToleranceRms`[get, set]`

Tolerance for RMS.

IVector IG::Neural::NeuralTrainingLimits::ToleranceMax`[get, set]`

Maximum tolerance for max. abs. difference.

IVector IG::Neural::NeuralTrainingLimits::ToleranceRmsRelativeToRange`[get, set]`

Relative tolerances on RMS errors of outputs over training points, relative to the correspoinding ranges of output data.

See also:
  NeuralApproximatorBase.ToleranceRmsRelativeToRange

double IG::Neural::NeuralTrainingLimits::ToleranceRmsRelativeToRangeScalar`[get, set]`

Scalar through which all components of the Relative tolerances on RMS errors of outputs can be set to the same value.

See also:
  NeuralApproximatorBase.ToleranceRmsRelativeToRangeScalar

IVector IG::Neural::NeuralTrainingLimits::ToleranceMaxRelativeToRange`[get, set]`

Relative tolerances on max. abs. errors of outputs over training points, relative to the correspoinding ranges of output data.

See also:
  NeuralApproximatorBase.ToleranceMaxRelativeToRange

double IG::Neural::NeuralTrainingLimits::ToleranceMaxRelativeToRangeScalar`[get, set]`

Scalar through which all components of the Relative tolerances on max. abs. errors of outputs can be set to the same value.

See also:
  NeuralApproximatorBase.ToleranceMaxRelativeToRangeScalar

bool IG::Neural::NeuralTrainingLimits::EnableArchitectureTest`[get, set]`

Flag for enabling test in architecture of ANN.

int IG::Neural::NeuralTrainingLimits::NumHiddenLayersNum`[get, set]`

Number of hidden layers in neural network.

int IG::Neural::NeuralTrainingLimits::NumHiddenNeuronsFirstMin`[get, set]`

Minimum number of hidden neurons in first hidden layer.

int IG::Neural::NeuralTrainingLimits::NumHiddenNeuronsFirstMax`[get, set]`

Maximum number of hidden neurons in first hidden layer.

int IG::Neural::NeuralTrainingLimits::NumHiddenNeuronsFirstNum`[get, set]`

Number of hidden neurons in first hidden layer.

int [] IG::Neural::NeuralTrainingLimits::NumHiddenNeuronsFirstValues`[get, set]`

Values of number of hidden neurons in the first layers that will appear in the table.

Specifying an array of values for the number of hidden neurons in the first layer makes possible to use custom values, not just equidistant values between minimal and maximal value.

If array of values is set, the number of values is set to the length of the array, minimal value is set to its first element and maximal value is set to its last element.

int IG::Neural::NeuralTrainingLimits::NumHiddenNeuronsSecondMin`[get, set]`

Minimum number of hidden neurons in second hidden layer.

int IG::Neural::NeuralTrainingLimits::NumHiddenNeuronsSecondMax`[get, set]`

Maximum number of hidden neurons in second hidden layer.

int IG::Neural::NeuralTrainingLimits::NumHiddenNeuronsSecondNum`[get, set]`

Number of hidden neurons in second hidden layer.

int [] IG::Neural::NeuralTrainingLimits::NumHiddenNeuronsSecondValues`[get, set]`

Values of number of hidden neurons in the second layers that will appear in the table.

Specifying an array of values for the number of hidden neurons in the second layer makes possible to use custom values, not just equidistant values between minimal and maximal value.

If array of values is set, the number of values is set to the length of the array, minimal value is set to its first element and maximal value is set to its last element.

int IG::Neural::NeuralTrainingLimits::NumHiddenNeuronsThirdMin`[get, set]`

Minimum number of hidden neurons in third hidden layer.

int IG::Neural::NeuralTrainingLimits::NumHiddenNeuronsThirdMax`[get, set]`

Maximum number of hidden neurons in third hidden layer.

int IG::Neural::NeuralTrainingLimits::NumHiddenNeuronsThirdNum`[get, set]`

Number of hidden neurons in third hidden layer.

int [] IG::Neural::NeuralTrainingLimits::NumHiddenNeuronsThirdValues`[get, set]`

Values of number of hidden neurons in the third layer that will appear in the table.

Specifying an array of values for the number of hidden neurons in the third layer makes possible to use custom values, not just equidistant values between minimal and maximal value.

If the array of values is set, the number of values is set to the length of the array, minimal value is set to its first element and maximal value is set to its last element.

The documentation for this class was generated from the following file:

- NeuralTrainingParameters.cs

All Classes Namespaces Files Functions Variables Enumerations Properties Events